public class Produits3DEnConsole {

/////////////////////////////////////////////////

/* Type agrege de stockage d'une direction     */
/* dans un espace trois dimensions             */
/* a coordonnees reelles                       */

  static class Direction3D {
    double x = 0.0;
    double y = 0.0;
    double z = 0.0; };

/* Calcul du produit scalaire de 2 Direction3D */

  static double produitScalaire(Direction3D d1,
                                Direction3D d2) {
    double res = d1.x*d2.x+d1.y*d2.y+d1.z*d2.z;
    return res;
  }

/* Calcul du produit vectoriel                 */
/* de 2 Direction3D                            */

  static Direction3D produitVectoriel(Direction3D d1,
                                      Direction3D d2) {
    Direction3D res = new Direction3D();
    res.x = d1.y*d2.z-d1.z*d2.y;
    res.y = d1.z*d2.x-d1.x*d2.z;
    res.z = d1.x*d2.y-d1.y*d2.x;
    return res;
  }

/* Programme principal                         */

  public static void main(String [] args) {
    Console.setTitle("Produits3D");
    Direction3D d1 = new Direction3D();
    Direction3D d2 = new Direction3D();
    double ps;
    Direction3D pv;
    Console.afficherln("Veuillez saisir la premiere direction");
    d1.x = Console.saisirDouble();
    d1.y = Console.saisirDouble();
    d1.z = Console.saisirDouble();
    Console.afficherln("Veuillez saisir la seconde direction");
    d2.x = Console.saisirDouble();
    d2.y = Console.saisirDouble();
    d2.z = Console.saisirDouble();
    ps = produitScalaire(d1,d2);
    pv = produitVectoriel(d1,d2);
    Console.afficherln("Produit scalaire : ",ps);
    Console.afficherln("Produit vectoriel : ",pv.x,", ",pv.y,", ",pv.z);
  }

/////////////////////////////////////////////////
}